library(tseries)
library(forecast)
library(imputeTS)

data_coins = read.csv("C:/Users/Administrator/Desktop/DataThone/CSVData_coin.csv")
View(data_coins)


data <- read.csv("C:/Users/Administrator/Desktop/DataThone/CryptoDataset/CryptoDataset/matrix_one_file/price_data.csv", as.is = T, header = T)


data_jan = data[1:2013,]

names(data_jan)

jan_data = data[c(144:2012),c("time","X1442","X1443","X1444","X1445","X1446","X1447","X1448","X1449","X1450","X1451","X1452","X1453","X1454","X1455","X1456","X1457","X1460","X1465","X1474","X1477")]


colSums(is.na(jan_data))


data_X1442 <- ts(as.numeric(jan_data$X1442), start = c(1, 1), frequency = 288)
impute_data_X1442 <- na.ma(data_X1442, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1442))


data_X1443 <- ts(as.numeric(jan_data$X1443), start = c(1, 1), frequency = 288)
impute_data_X1443 <- na.ma(data_X1443, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1443))


data_X1444 <- ts(as.numeric(jan_data$X1444), start = c(1, 1), frequency = 288)
impute_data_X1444 <- na.ma(data_X1444, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1444))



data_X1445 <- ts(as.numeric(jan_data$X1445), start = c(1, 1), frequency = 288)
impute_data_X1445 <- na.ma(data_X1445, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1445))

data_X1446 <- ts(as.numeric(jan_data$X1446), start = c(1, 1), frequency = 288)
impute_data_X1446 <- na.ma(data_X1446, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1446))


data_X1447 <- ts(as.numeric(jan_data$X1447), start = c(1, 1), frequency = 288)
impute_data_X1447 <- na.ma(data_X1447, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1447))



data_X1448 <- ts(as.numeric(jan_data$X1448), start = c(1, 1), frequency = 288)
impute_data_X1448 <- na.ma(data_X1448, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1448))



data_X1449 <- ts(as.numeric(jan_data$X1449), start = c(1, 1), frequency = 288)
impute_data_X1449 <- na.ma(data_X1449, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1449))


data_X1450 <- ts(as.numeric(jan_data$X1450), start = c(1, 1), frequency = 288)
impute_data_X1450 <- na.ma(data_X1450, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1450))



data_X1451 <- ts(as.numeric(jan_data$X1451), start = c(1, 1), frequency = 288)
impute_data_X1451 <- na.ma(data_X1451, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1451))



data_X1452 <- ts(as.numeric(jan_data$X1452), start = c(1, 1), frequency = 288)
impute_data_X1452 <- na.ma(data_X1452, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1452))


data_X1453 <- ts(as.numeric(jan_data$X1453), start = c(1, 1), frequency = 288)
impute_data_X1453 <- na.ma(data_X1453, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1453))


data_X1454 <- ts(as.numeric(jan_data$X1454), start = c(1, 1), frequency = 288)
impute_data_X1454 <- na.ma(data_X1454, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1454))


data_X1455 <- ts(as.numeric(jan_data$X1455), start = c(1, 1), frequency = 288)
impute_data_X1455 <- na.ma(data_X1455, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1455))


data_X1456 <- ts(as.numeric(jan_data$X1456), start = c(1, 1), frequency = 288)
impute_data_X1456 <- na.ma(data_X1456, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1453))


data_X1457 <- ts(as.numeric(jan_data$X1457), start = c(1, 1), frequency = 288)
impute_data_X1457 <- na.ma(data_X1457, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1457))


data_X1460 <- ts(as.numeric(jan_data$X1460), start = c(1, 1), frequency = 288)
impute_data_X1460 <- na.ma(data_X1460, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1460))


data_X1465 <- ts(as.numeric(jan_data$X1465), start = c(1, 1), frequency = 288)
impute_data_X1465 <- na.ma(data_X1465, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1465))

data_X1474 <- ts(as.numeric(jan_data$X1474), start = c(1, 1), frequency = 288)
impute_data_X1474 <- na.ma(data_X1474, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1474))

data_X1477 <- ts(as.numeric(jan_data$X1477), start = c(1, 1), frequency = 288)
impute_data_X1477 <- na.ma(data_X1477, k = 2, weighting = "exponential")
sum(is.na(impute_data_X1477))

time = jan_data[,1]

d = cbind(time,impute_data_X1442,impute_data_X1443)

data = data.frame(time,impute_data_X1442,
                             impute_data_X1443,impute_data_X1444,impute_data_X1445,
                             impute_data_X1446,impute_data_X1447,impute_data_X1448,
                             impute_data_X1449,impute_data_X1450,impute_data_X1451,
                             impute_data_X1452,impute_data_X1453,impute_data_X1454,
                             impute_data_X1455,impute_data_X1456,impute_data_X1457,
                             impute_data_X1460,impute_data_X1465,impute_data_X1474,
                             impute_data_X1477)




###################################################################################
pred_cur <- function(df){
  for(i in 3:length(colnames(df))){
    # Predicting for each column
    data1 <- df[,c(1,2,i)]
    # Changing the date & time formate of the data
    data1$time <- dmy_hm(data1$time)
    
    # Creating sequence
    s <- seq(as.POSIXct("2018-1-18 00:00"), as.POSIXct("2018-1-24 23:55"), by = "5 min")
    s <- ymd_hms(s)
    s <- as.data.frame(s)
    colnames(s) <- c("time")
    
    # Merging the data
    new_data <- merge(x = data1, y = s, by = "time", all.y = TRUE)
    
    # Making time series data
    data_impute <- ts(new_data[,i], start = c(1, 1), frequency = 288)
    
    # Imputing missing values
    data_impute <- na.ma(data_impute, k = 2, weighting = "exponential")
    values <- data_impute
    # Predicting next day prices
    for(j in 1:5){
      csv <- c()
      for(i in 1:288){
        fitn = nnetar(values)
        fore = forecast(fitn,h=1)
        values = unlist(values)
        df = as.data.frame(fore)
        csv <- c(csv, df[1,1] )
        values = c(values, df[1,1] )[-1]
        values = ts(values, start = c(1, 1), frequency = 288)
      }
      path = c("/Users/supriodutta/Desktop/datahon/Day1_")
      var = c(".csv")
      full_path <- paste(path,colnames(data[i]),j,var,sep = "")
      
      write.csv(csv, file= full_path)
    }
  }
}

pred_cur(data)